<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/damage.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/damage.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2006 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_DAMAGE__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_DAMAGE__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00059"></a><a class="code" href="structiPcDamage.html">00059</a> <span class="keyword">struct </span><a class="code" href="structiPcDamage.html" title="This is a property class for damage emitting.">iPcDamage</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   SCF_INTERFACE (<a class="code" href="structiPcDamage.html" title="This is a property class for damage emitting.">iPcDamage</a>, 0, 0, 1);
<a name="l00062"></a>00062 
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#af6059197dbcbd10bb767510a67b26bb8" title="Set the amount of damage.">SetDamage</a> (<span class="keywordtype">float</span> amount) = 0;
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcDamage.html#a8b197964e726cf696f36c39a5252a1e0" title="Get the amount of damage.">GetDamage</a> () <span class="keyword">const</span> = 0;
<a name="l00067"></a>00067 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#a70aa3120b257e09c48d78a4ee3c44cc3" title="Set the type of damage.">SetDamageType</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* type) = 0;
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcDamage.html#af503349584bd773703fbfdd1bd89a14d" title="Get the type of damage.">GetDamageType</a> () <span class="keyword">const</span> = 0;
<a name="l00072"></a>00072 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#a72925693bd06f1577f20854f7d385753" title="Set the damage falloff (&#39;constant&#39;, &#39;normal&#39;, or &#39;linear&#39;).">SetFallOff</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* f) = 0;
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcDamage.html#aacb49bf0a2a8d67b8abfdc0a5ffb8458" title="Get the damage falloff.">GetFallOff</a> () <span class="keyword">const</span> = 0;
<a name="l00080"></a>00080 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#ad54cd2cc86197763b45b9f6977ef558c" title="Set the source location for the damage.">SetDamageLocation</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* sectorname,
<a name="l00087"></a>00087       <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; pos) = 0;
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcDamage.html#ae67a3d33b3d9fde7de7ea24f0392bd95" title="Get the source sector for the damage (only if explicitly set).">GetDamageSector</a> () <span class="keyword">const</span> = 0;
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="code" href="structiPcDamage.html#a4ee0556af53982c22e23583b2cce8ef5" title="Get the source position for the damage (only if explicitly set).">GetDamagePosition</a> () <span class="keyword">const</span> = 0;
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#a16630497b6af52911410609bb92a564a" title="Set the source name for the damage.">SetDamageSource</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* source) = 0;
<a name="l00098"></a>00098 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcDamage.html#a7e2d0fe3e5a0326bf028fdb40fc26dbb" title="Get the source name for the damage.">GetDamageSource</a>() <span class="keyword">const</span> = 0;
<a name="l00101"></a>00101 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#a859696cf5c2cab762ced30c78855ff56" title="Do area damage.">AreaDamage</a> (<span class="keywordtype">float</span> radius) = 0;
<a name="l00104"></a>00104 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#af7b751c8aec2168c5efed873d8d33b1c" title="Do beam damage.">BeamDamage</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; direction, <span class="keywordtype">float</span> maxdist) = 0;
<a name="l00107"></a>00107 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcDamage.html#ac1873aef7000611516b3864ad4c5840b" title="Do single damage.">SingleDamage</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* target) = 0;
<a name="l00110"></a>00110 };
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#endif // __CEL_PF_DAMAGE__</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
